2 # Copyright (c) 2007, Nanako Shiraishi
4 dashless=$(basename "$0" | sed -e 's/-/ /')
5 USAGE="list [<options>]
6 or: $dashless show [<stash>]
7 or: $dashless drop [-q|--quiet] [<stash>]
8 or: $dashless ( pop | apply ) [--index] [-q|--quiet] [<stash>]
9 or: $dashless branch <branchname> [<stash>]
10 or: $dashless [save [--patch] [-k|--[no-]keep-index] [-q|--quiet] [<message>]]
20 TMP="$GIT_DIR/.git-stash.$$"
21 TMPindex=${GIT_INDEX_FILE-"$GIT_DIR/index"}.stash.$$
22 trap 'rm -f "$TMP-"* "$TMPindex"' 0
26 if git config --get-colorbool color.interactive; then
27 help_color="$(git config --get-color color.interactive.help 'red bold')"
28 reset_color="$(git config --get-color '' reset)"
35 git diff-index --quiet --cached HEAD --ignore-submodules -- &&
36 git diff-files --quiet --ignore-submodules
42 die "git stash clear with parameters is unimplemented"
44 if current=$(git rev-parse --verify $ref_stash 2>/dev/null)
46 git update-ref -d $ref_stash $current
53 git update-index -q --refresh
59 # state of the base commit
60 if b_commit=$(git rev-parse --verify HEAD)
62 head=$(git rev-list --oneline -n 1 HEAD --)
64 die "You do not have the initial commit yet"
67 if branch=$(git symbolic-ref -q HEAD)
69 branch=${branch#refs/heads/}
73 msg=$(printf '%s: %s' "$branch" "$head")
76 i_tree=$(git write-tree) &&
77 i_commit=$(printf 'index on %s\n' "$msg" |
78 git commit-tree $i_tree -p $b_commit) ||
79 die "Cannot save the current index state"
81 if test -z "$patch_mode"
84 # state of the working tree
86 git read-tree --index-output="$TMPindex" -m $i_tree &&
87 GIT_INDEX_FILE="$TMPindex" &&
88 export GIT_INDEX_FILE &&
89 git diff --name-only -z HEAD | git update-index -z --add --remove --stdin &&
93 die "Cannot save the current worktree state"
98 GIT_INDEX_FILE="$TMP-index" git read-tree HEAD &&
100 # find out what the user wants
101 GIT_INDEX_FILE="$TMP-index" \
102 git add--interactive --patch=stash -- &&
104 # state of the working tree
105 w_tree=$(GIT_INDEX_FILE="$TMP-index" git write-tree) ||
106 die "Cannot save the current worktree state"
108 git diff-tree -p HEAD $w_tree > "$TMP-patch" &&
109 test -s "$TMP-patch" ||
110 die "No changes selected"
112 rm -f "$TMP-index" ||
113 die "Cannot remove temporary index (can't happen)"
118 if test -z "$stash_msg"
120 stash_msg=$(printf 'WIP on %s' "$msg")
122 stash_msg=$(printf 'On %s: %s' "$branch" "$stash_msg")
124 w_commit=$(printf '%s\n' "$stash_msg" |
125 git commit-tree $w_tree -p $b_commit -p $i_commit) ||
126 die "Cannot record working tree state"
143 # only default to keep if we don't already have an override
144 test -z "$keep_index" && keep_index=t
154 echo "error: unknown option for 'stash save': $1"
155 echo " To provide a message, use git stash save -- '$1'"
167 git update-index -q --refresh
170 say 'No local changes to save'
173 test -f "$GIT_DIR/logs/$ref_stash" ||
174 clear_stash || die "Cannot initialize stash"
176 create_stash "$stash_msg"
178 # Make sure the reflog for stash is kept.
179 : >>"$GIT_DIR/logs/$ref_stash"
181 git update-ref -m "$stash_msg" $ref_stash $w_commit ||
182 die "Cannot save the current status"
183 say Saved working directory and index state "$stash_msg"
185 if test -z "$patch_mode"
187 git reset --hard ${GIT_QUIET:+-q}
189 if test "$keep_index" = "t" && test -n $i_tree
191 git read-tree --reset -u $i_tree
194 git apply -R < "$TMP-patch" ||
195 die "Cannot remove worktree changes"
197 if test "$keep_index" != "t"
205 git rev-parse --verify $ref_stash >/dev/null 2>&1
209 have_stash || return 0
210 git log --format="%gd: %gs" -g "$@" $ref_stash --
214 assert_stash_like "$@"
216 git diff ${FLAGS:---stat} $b_commit $w_commit
220 # Parses the remaining options looking for flags and
221 # at most one revision defaulting to ${ref_stash}@{0}
224 # Derives related tree and commit objects from the
225 # revision, if one is found.
227 # stash records the work tree, and is a merge between the
228 # base commit (first parent) and the index tree (second parent).
230 # REV is set to the symbolic version of the specified stash-like commit
231 # IS_STASH_LIKE is non-blank if ${REV} looks like a stash
232 # IS_STASH_REF is non-blank if the ${REV} looks like a stash ref
233 # s is set to the SHA1 of the stash commit
234 # w_commit is set to the commit containing the working tree
235 # b_commit is set to the base commit
236 # i_commit is set to the commit containing the index tree
237 # w_tree is set to the working tree
238 # b_tree is set to the base tree
239 # i_tree is set to the index tree
241 # GIT_QUIET is set to t if -q is specified
242 # INDEX_OPTION is set to --index if --index is specified.
243 # FLAGS is set to the remaining flags
246 # * too many revisions specified
247 # * no revision is specified and there is no stash stack
248 # * a revision is specified which cannot be resolve to a SHA1
249 # * a non-existent stash reference is specified
252 parse_flags_and_rev()
254 test "$PARSE_CACHE" = "$*" && return 0 # optimisation
268 REV=$(git rev-parse --no-flags --symbolic "$@") || exit 1
281 FLAGS="${FLAGS}${FLAGS:+ }$opt"
290 have_stash || die "No stash found."
291 set -- ${ref_stash}@{0}
297 die "Too many revisions specified: $REV"
301 REV=$(git rev-parse --quiet --symbolic --verify $1 2>/dev/null) || die "$1 is not valid reference"
303 i_commit=$(git rev-parse --quiet --verify $REV^2 2>/dev/null) &&
304 set -- $(git rev-parse $REV $REV^1 $REV: $REV^1: $REV^2: 2>/dev/null) &&
312 test "$ref_stash" = "$(git rev-parse --symbolic-full-name "${REV%@*}")" &&
318 parse_flags_and_rev "$@"
319 test -n "$IS_STASH_LIKE"
322 assert_stash_like() {
323 is_stash_like "$@" || die "'$*' is not a stash-like commit"
327 is_stash_like "$@" && test -n "$IS_STASH_REF"
331 is_stash_ref "$@" || die "'$*' is not a stash reference"
336 assert_stash_like "$@"
338 git update-index -q --refresh || die 'unable to refresh index'
340 # current index state
341 c_tree=$(git write-tree) ||
342 die 'Cannot apply a stash in the middle of a merge'
344 unstashed_index_tree=
345 if test -n "$INDEX_OPTION" && test "$b_tree" != "$i_tree" &&
346 test "$c_tree" != "$i_tree"
348 git diff-tree --binary $s^2^..$s^2 | git apply --cached
350 die 'Conflicts in index. Try without --index.'
351 unstashed_index_tree=$(git write-tree) ||
352 die 'Could not save index tree'
357 GITHEAD_$w_tree='Stashed changes' &&
358 GITHEAD_$c_tree='Updated upstream' &&
359 GITHEAD_$b_tree='Version stash was based on' &&
360 export GITHEAD_$w_tree GITHEAD_$c_tree GITHEAD_$b_tree
363 if test -n "$GIT_QUIET"
365 GIT_MERGE_VERBOSITY=0 && export GIT_MERGE_VERBOSITY
367 if git merge-recursive $b_tree -- $c_tree $w_tree
370 if test -n "$unstashed_index_tree"
372 git read-tree "$unstashed_index_tree"
375 git diff-index --cached --name-only --diff-filter=A $c_tree >"$a" &&
376 git read-tree --reset $c_tree &&
377 git update-index --add --stdin <"$a" ||
378 die "Cannot unstage modified files"
382 if test -n "$GIT_QUIET"
384 squelch='>/dev/null 2>&1'
386 (cd "$START_DIR" && eval "git status $squelch") || :
388 # Merge conflict; keep the exit status from merge-recursive
390 if test -n "$INDEX_OPTION"
392 echo >&2 'Index was not unstashed.'
399 assert_stash_ref "$@"
406 assert_stash_ref "$@"
408 git reflog delete --updateref --rewrite "${REV}" &&
409 say "Dropped ${REV} ($s)" || die "${REV}: Could not drop stash entry"
411 # clear_stash if we just dropped the last stash entry
412 git rev-parse --verify "$ref_stash@{0}" > /dev/null 2>&1 || clear_stash
416 test -n "$1" || die 'No branch name specified'
421 assert_stash_like "$@"
423 git checkout -b $branch $REV^ &&
424 apply_stash "$@" && {
425 test -z "$IS_STASH_REF" || drop_stash "$@"
429 PARSE_CACHE='--not-parsed'
430 # The default command is "save" if nothing but options are given
436 *) seen_non_option=t; break ;;
440 test -n "$seen_non_option" || set "save" "$@"
465 if test $# -gt 0 && test "$1" = create
469 create_stash "$*" && echo "$w_commit"
487 say '(To restore them type "git stash apply")'